<?php

/**
 * UserIdentity represents the data needed to identity a user.
 * It contains the authentication method that checks if the provided
 * data can identity the user.
 */
class UserIdentity extends CUserIdentity
{
	/**
	 * Authenticates a user.
	 * The example implementation makes sure if the username and password
	 * are both 'demo'.
	 * In practical applications, this should be changed to authenticate
	 * against some persistent user identity storage (e.g. database).
	 * @return boolean whether authentication succeeds.
	 */
	public $_id;
	public function authenticate()
	{
		$usuaris=$this->getUser();
		$users=array(
			// username => password
			'demo'=>array('demo',0),
		);
		foreach($usuaris as $usuari){
			$users[$usuari['Usuari']]=array($usuari['Contrasenya'],$usuari['Poder']);
		}
//		$record=Yii::app()->user;
		if(!isset($users[$this->username]))
			$this->errorCode=self::ERROR_USERNAME_INVALID;
		elseif($users[$this->username][0]!==$this->password)
			$this->errorCode=self::ERROR_PASSWORD_INVALID;
		else{
			$this->_id=$users[$this->username][1];
//			$record->setState('__id',$users[$this->username][1],null);
			$this->errorCode=self::ERROR_NONE;
		}

		return !$this->errorCode;
	}
	
	public function getUser(){
		$db= new CDbConnection(Yii::app()->db->connectionString,Yii::app()->db->username,Yii::app()->db->password);
		$db->active=true;
		$sql="SELECT * FROM USUARIS";
		$command=$db->createCommand($sql);
		$users=$command->queryAll();
		$db->active=false;
		return $users;
	}
	
	public function getId()
	{
		return $this->_id;
	}
}