<?php
class WebApplicationEndBehavior extends CBehavior{
	//Nom de le l'end de l'applicaci�
	private $_endName;
	
	//Getter, permet aconseguir el nom de l'end actual
	//fent Yii::app()->endName;
	public function getEndName(){
		return $this->_endName;
	}
	
	//Run application's end
	public function runEnd($name){
		$this->_endName = $name;
		
		//ajunta el changeModulePaths event handler
		$this->onModuleCreate=array($this,'changeModulePaths');
		$this->onModuleCreate(new CEvent($this->owner));
		
		$this->owner->run(); // run application
	}
	
	//this event shloud be raised when CWebApplication or CWebModule instances are being initialized
	public function onModuleCreate($event){
		$this->raiseEvent('onModuleCreate',$event);
	}
	
	//onModuleCreate event handler
	//A sender must have controllerPath and viewPath properties
	protected function changeModulePaths($event){
		$event->sender->controllerPath .=DIRECTORY_SEPARATOR.$this->_endName;
		$event->sender->viewPath .= DIRECTORY_SEPARATOR.$this->_endName;
	}
}