<?php

class SiteController extends BackEndController
{
	public function filters(){
		ini_set('display_errors', 1);
		return array(
				'accessControl',
		);
	}
	
	public function accessRules(){
		return array(
				array(
						'allow',
						'expression'=>("Yii::app()->user->id=='Administrador'"),	
				),
				array(
						'allow',
						'ips'=>array('127.0.0.1'),
				),
				array(
						'deny',
						'deniedCallback'=>function(){Yii::app()->controller->redirect('/site/index');},
						'users'=>array('*'),
				),
		);
	}
	/**
	 * Declares class-based actions.
	 */
	public function actions()
	{
		
		return array(
			// captcha action renders the CAPTCHA image displayed on the contact page
			'captcha'=>array(
				'class'=>'CCaptchaAction',
				'backColor'=>0xFFFFFF,
			),
			// page action renders "static" pages stored under 'protected/views/site/pages'
			// They can be accessed via: index.php?r=site/page&view=FileName
			'page'=>array(
				'class'=>'CViewAction',
			),
		);
	}

	/**
	 * This is the default 'index' action that is invoked
	 * when an action is not explicitly requested by users.
	 */
	public function actionIndex()
	{
		// renders the view file 'protected/views/site/index.php'
		// using the default layout 'protected/views/layouts/main.php'
		if(!Yii::app()->user->id=='Administrador'||CHttpRequest::getUserHostAddress()=='127.0.0.1'){
			$this->render('index');
		} else {
			$this->redirect('/site/index');
		}
	}

	/**
	 * This is the action to handle external exceptions.
	 */
	public function actionError()
	{
		if($error=Yii::app()->errorHandler->error)
		{
			if(Yii::app()->request->isAjaxRequest)
				echo $error['message'];
			else
				$this->render('error', $error);
		}
	}

	public function actionBdMeteo(){
		ini_set('display_errors', 1);
		//obtenir LLista d'arxius del servidor extern
		try{
			$meteo = new Meteo();
			$bdpropia= new Bdades();
			$fitxers=$meteo->getMeteoList();
	
		} catch (Exception $e){
			$e->getMessage();
			die("ERROR: ".$e);
				
		}
		//Comparar arxius del servidor extern amb els k ja tenim descarregats a la carpeta tempmeteo
		// i descarregar els que falten
		$fitxersguardats=$meteo->newMeteoFile($fitxers);
	
		//ultima data guardada al nostre servidor
		$ultimregaux=$bdpropia->getUltimreg("METEO");
		//pasar de UTC a horari español
		$ultimreg=$ultimregaux;
		//pasar de UTCData a UTCnumeric (treure - i :)
		$ultimregaux=str_replace('-','',$ultimregaux);
		$ultimregaux=str_replace(':','',$ultimregaux);
		$ultimregaux=str_replace(' ','',$ultimregaux);

		//Lista de tots els arxius que hi ha descarregats al servidor
		$fitxers = scandir(Yii::getPathOfAlias('webroot')."/tempmeteo");
		//Eliminar els primers 4 elements dels fitxers perque son les carpetes pare o
		// elements que no volem
		array_splice($fitxers,0,4);
		//ordenar els fitxers
		$fitxers= $meteo->newLastDateFiles($fitxers,$ultimregaux);
		//Agafem la llista de fitxers en grup petits per evitar arrays que ens ocupin tota la memoria
		$nfitxers=count($fitxers);
		if($nfitxers>0){
			$i=0;
			$p=[];
			//augmentar el temps d'esperra perque no salti error;
			while($i<$nfitxers){
				$fitxersaux=[];
				$tempdad=[];
				for($j=0;$j<13;$j++){
					if($i<$nfitxers){
						$fitxersaux[]=$fitxers[$i];
						$i++;
					}
				}
				$tempdad=$meteo->getFilesData($fitxersaux);
				while(count($tempdad)<25000&&$i<$nfitxers){
					$tempdad=[];
					$fitxersaux[]=$fitxers[$i];
					$tempdad=$meteo->getFilesData($fitxersaux);
					$i++;
				}
				//Agafem la informació de dins dels arxius
				$p[]=array($fitxersaux,count($tempdad));
				//Agafar les columnes 2,3 i 4 de tempdad i crear la data i l'hora en UTC
				$tempdad=$meteo->createFileDate($tempdad);
				//tornem a ordenar per si alguna dade a quedat desubicada
				sort($tempdad);
				//eliminem dades duplicades i inferiors a l'ultim registre
				$tempdad=$meteo->deletDuplicated($tempdad,$ultimregaux);
				$p2[]=count($tempdad);
				//guardar les dades a la base de dades;
				$bdpropia->insertMeteo($tempdad);
				//guardar l'ultim tempdad per a la proxima iteraci�
				if(count($tempdad)>0){
					$ultimregaux=$tempdad[count($tempdad)-1][0];
				}
			}
		}
		$this->redirect(Yii::app()->request->urlReferrer);
	}
	
	public function actionBdMeshlium(){
		Yii::trace('0- inici','Projecte');
		ini_set('display_errors', 1);
		ini_set('memory_limit', '2048M');
		Yii::trace('0- inici try','Projecte');
		try{
			Yii::trace('0- Mehslium','Projecte');
			$meshlium = new Meshlium();
			Yii::trace('0- Bdades','Projecte');
			$bdpropia= new Bdades();
			Yii::trace('0- fi Bdades','Projecte');
		} catch (Exception $e){
			$e->getMessage();
			die("ERROR: ".$e);
		}
		$ultimregvell=null;
		$linies=0;
		$sensors=$bdpropia->getSensors();
		Yii::trace('1- inici getMeshliumUltimreg','Projecte');
		$tempsMaxVell=$meshlium->getMaxMeshlium($sensors,"vell");
		$tempsMaxNou=$meshlium->getMaxMeshlium($sensors,"nou");
		$ultimreg=$bdpropia->getUltimreg("MESHLIUM");
		$ultimregaux=$ultimreg;
		if($ultimreg<$tempsMaxVell){
			Yii::trace('2- MeshliumVell','Projecte');
			$retorn=$this->actionBdMeshliumVell($meshlium,$bdpropia,$tempsMaxVell,$sensors);
			$ultimregvell=$retorn[0];
			$linies=$retorn[1];
			$ultimreg=$ultimregvell;
		}
		if($tempsMaxNou>=$ultimreg){
			Yii::trace('3- MeshliumNou','Projecte');
			$retorn=$tempsMaxNou=$this->actionBdMeshliumNou($meshlium,$bdpropia,$ultimregvell,$sensors);
			$ultimreg=$retorn[0];
			$linies=$linies+$retorn[1];
		}	
		$this->redirect(Yii::app()->request->urlReferrer);
	}
	
	private function actionBdMeshliumNou($meshlium,$bdpropia,$ultimregvell,$sensors){
		
		if($ultimregvell==null){
			$bdpropia->deletMeshliumUltimreg();
			$ultimreg=$bdpropia->getUltimreg("MESHLIUM");
		} else {
			$ultimreg=$ultimregvell;
		}
		Yii::trace('2- inici getMeshliumdata','Projecte');
		$dades=$meshlium->getMeshliumdata($ultimreg,$sensors,"nou");
		
		//Separar per sensors i agafar les dades que volem
		Yii::trace('3- Inici areglar','Projecte');
		$dades2=$meshlium->areglarNou($dades,$ultimreg);
		//guardar les dades a la nostra base de dades
		Yii::trace('4- inici insertMeshlium','Projecte');
		$bdpropia->insertMeshlium($dades2);
		Yii::trace('5- final insert','Projecte');
		$tornar[0]=$dades2[count($dades2)-1][1];
		$tornar[1]=count($dades2);
		return $tornar;
	}
	
	private function actionBdMeshliumVell($meshlium,$bdpropia,$tempsMaxVell,$sensors){		
		//Eliminar ultima data guardada a la BD per si no es va actualitzar amb totes les dades
		Yii::trace('2.1- delet Mehslium Ultimreg','Projecte');
		$bdpropia->deletMeshliumUltimreg();
		//Agafar ultim temps guardat a la nostre base de dades
		$ultimreg=$bdpropia->getUltimreg("MESHLIUM");
		//Agafar l'informació del Meshlium per cada sensor
		Yii::trace('2.2- inici getMeshliumdata','Projecte');
		$dades=$meshlium->getMeshliumdata($ultimreg,$sensors,"vell");
		//Separar per sensors i agafar les dades que volem
		Yii::trace('2.3- Inici areglar','Projecte');
		$dades2=$meshlium->areglarVell($dades,$ultimreg);
		//guardar les dades a la nostra base de dades
		Yii::trace('2.4- inici insertMeshlium','Projecte');
		$bdpropia->insertMeshlium($dades2);
		Yii::trace('2.5- final insert','Projecte');
		$tornar[0]=$dades2[count($dades2)-1][1];
		$tornar[1]=count($dades2);
		return $tornar;
	}
	
	public function SendMail($desti,$subject,$body){
		$mail = new JPhpMailer;
		$mail->IsSMTP();
		$mail->Host = 'smtp.gmail.com:465';
		$mail->SMTPAuth = true;
		$mail->Username = 'exitsuperpizza@gmail.com';
		$mail->Password = 'hotdog1!';
		$mail->SMTPSecure = "ssl";
		$mail->SetFrom('exitsuperpizza@gmail.com', 'superpizza');
		$mail->Subject = $subject;
		$mail->MsgHTML($body);
		$mail->AddAddress($desti,$desti);
		$mail->Send();
	}
	
	public function actionUpdateSBattery(){
		Yii::trace('0- inici','Projecte');
		ini_set('display_errors', 1);
		ini_set('memory_limit', '2048M');
		Yii::trace('0- inici try','Projecte');
		try{
			Yii::trace('0- Mehslium','Projecte');
			$meshlium = new Meshlium();
			Yii::trace('0- Bdades','Projecte');
			$bdpropia= new Bdades();
			Yii::trace('0- fi Bdades','Projecte');
		} catch (Exception $e){
			$e->getMessage();
			die("ERROR: ".$e);
		}
		$linies=0;
		Yii::trace('0- fi try','Projecte');
		//Eliminar ultima data guardada a la BD per si no es va actualitzar amb totes les dades
		$bdpropia->deletSensorsBatteryUltimreg();
		//Agafar ultim temps guardat a la nostre base de dades
		Yii::trace('1- inici geSensorsBatteryUltimreg','Projecte');
		$ultimreg=$bdpropia->getUltimreg("SensorsBattery");
		$ultimregaux=$ultimreg;
		//Afagar els sensors
		$sensors=$bdpropia->getSensors();
		$tempsMaxVell=$meshlium->getMaxMeshlium($sensors,"vell");
		$tempsMaxNou=$meshlium->getMaxMeshlium($sensors,"nou");
		Yii::trace('2- Meshlium Vell','Projecte');
		if($ultimreg<$tempsMaxVell){
			//Agafar l'informació del Meshlium per cada sensor
			Yii::trace('2.1- inici getMeshliumdata','Projecte');
			$dades=$meshlium->getMeshBatterydataVell($ultimreg,$sensors);
			//Separar per sensors i agafar les dades que volem
			Yii::trace('2.2- Inici areglar','Projecte');
			$return=$meshlium->areglarBatteryVell($dades,$ultimreg);
			$dades2=$return[1];
			$ultimreg=$dades2[$return[0]-1][1];
			$linies=$return[0];
			//guardar les dades a la nostra base de dades
			Yii::trace('2.3- inici insertMeshlium','Projecte');
			$bdpropia->insertSensorsBattery($dades2);
			Yii::trace('2.4- final insert','Projecte');
		}
		Yii::trace('3- Meshlium Nou','Projecte');
		if($ultimreg<$tempsMaxNou){
			//Agafar l'informació del Meshlium per cada sensor
			Yii::trace('3.1- inici getMeshliumdata','Projecte');
			$dades=$meshlium->getMeshBatterydataNou($ultimreg,$sensors);
			//Separar per sensors i agafar les dades que volem
			Yii::trace('3.2- Inici areglar','Projecte');
			$dades2=$meshlium->areglarBatteryNou($dades,$ultimreg);
			//guardar les dades a la nostra base de dades
			Yii::trace('3.3- inici insertMeshlium','Projecte');
			$linies=$linies+count($dades2);
			$bdpropia->insertSensorsBattery($dades2);
			Yii::trace('3.4- final insert','Projecte');
		}
		
 		//comprovar Bateria actual i lultima guardara i enviar correu si fa falta
		foreach ($dades2[count($dades2)-1] as $key=>$dada){
			if($key!=0){
				$bat[$key]=$dades2[count($dades2)-1][$key];
			}
		}
		
		Yii::trace('6- insert Bat','Projecte');
		$correus=$bdpropia->getCorreus();
		foreach ($correus as $correu){
			unset($missatge);
			Yii::trace('6- Correu','Projecte');
			foreach ($sensors as $b){
				Yii::trace('6- Sensor','Projecte');
				if($bat[$b['Sensor']]<=$b['Bateria']&&$b['Bateria']<=$correu['Nivell_Bat']){
					if(isset($missatge)){
						$missatge=$missatge."</br> Mac: ".$b['baixMAC']."->Batteria: ".$bat[$b['Sensor']];
					} else {
						$missatge="Els sensors següents tenen la bateria per sota del ".$correu['Nivell_Bat']."%: </br>Mac: ".$b['baixMAC']."->Batteria: ".$bat[$b['Sensor']];
					}
				}
	
				$bdpropia->UpdateBatSensors($bat[$b['Sensor']],$b['Sensor']);
					}
			if(isset($missatge)){
				$this->SendMail($correu['correu'],"Bateria Waspmote",$missatge);		
			}		
		}
		$this->redirect(Yii::app()->request->urlReferrer);
	}
	
	public function actionUpdateEnergia(){
		Yii::trace('0- inici','Projecte');
		ini_set('display_errors', 1);
		ini_set('memory_limit', '4096M');
		set_time_limit(864000);
		Yii::trace('0- inici try','Projecte');
		try{
			Yii::trace('0- Mehslium','Projecte');
			$energia = new Energia();
			Yii::trace('0- Bdades','Projecte');
			$bdpropia= new Bdades();
			Yii::trace('0- fi Bdades','Projecte');
		} catch (Exception $e){
			$e->getMessage();
			die("ERROR: ".$e);
		}
		Yii::trace('1- getEdificisInfo','Projecte');
		$edificis=$bdpropia->getEnergiaEdificis();
		Yii::trace('2- getEnergiaUltimreg','Projecte');
		$ultimreg=$bdpropia->getUltimreg("ENERGIA");
		//actualitzar per part perque hi ha molta info
		//agafar 10.000 dades cada vegada
		$ultimtemp=$ultimreg;
		if($ultimreg==0){
			//			$ultimreg="2009-02-16 12:00:00:000AM"
			//$ultimreg="Mar 03 2009 12:00:00:000AM"
			$dades=$energia->getEnergiaTemps($edificis);
			if($dades!=null){
				$ultimreg=$energia->PrimerTemps($dades);
				$ultimreg=$bdpropia->UTCtoUTCN($ultimreg);
			}
		} else {
			$dades=1;
			$ultimreg=$bdpropia->UTCtoUTCN($ultimreg);
			$ultimreg=$bdpropia->UTCNaddtime($ultimreg,15);
		}
		
		//agafar ultim registre més actual
		$dades=$energia->getEnergiaMaxTemps($edificis);
		if($dades!=null){
			$maxreg=$energia->UltimTemps($dades);
		}
		$maxtemp=$maxreg;
		$maxreg=$bdpropia->UTCtoUTCN($maxreg);
		//nombre de linies afegides
		$i=0;
		Yii::trace('3- Iniciar while','Projecte');
		while($maxreg>=$ultimreg){
			//Passar la data al format de la base de dades
			$ultimreg=$bdpropia->UTCNtoUTC($ultimreg);
			$ultimregaux=$energia->Time24to12($ultimreg);
			//Agafar la info
			Yii::trace('4- Iniciar while','Projecte');
			$dades=$energia->getEnergia($ultimregaux,$edificis);
			//guardarla a la nostra base de dades
			Yii::trace('5- Iniciar while','Projecte');
			$bdpropia->insertEnergia($ultimreg,$dades,$edificis);
			//modificar la data per sumar 15 minuts 
			$ultimreg=$bdpropia->UTCtoUTCN($ultimreg);
			$ultimreg=$bdpropia->UTCNaddtime($ultimreg,15);
			$i++;
		}
		
		Yii::trace('3- Fi','Projecte');

		$this->redirect(Yii::app()->request->urlReferrer);
	}
	
	public function actionUsuaris(){
		$this->layout='//layouts/column2';
		$model=new USUARIS('search');
		$model->unsetAttributes();  // clear any default values
		if(isset($_GET['USUARIS']))
			$model->attributes=$_GET['USUARIS'];
		
		$this->render('Usuarisadmin',array(
				'model'=>$model,
		));
	}
	
	public function actionCreateUsuaris()
	{
		$this->layout='//layouts/column2';
		$model=new USUARIS;
	
		if(isset($_POST['USUARIS']))
		{
			$_POST['USUARIS']['Contrasenya']=md5($_POST['USUARIS']['Contrasenya']);
			$model->attributes=$_POST['USUARIS'];
			if($model->save())
				$this->redirect(array('/back/site/Usuaris'));
		}
	
		$this->render('Usuariscreate',array(
				'model'=>$model,
		));
	}
	
	public function actionUpdateUsuaris($id)
	{
		$this->layout='//layouts/column2';
		$model=$this->loadModel($id);
	
	
		if(isset($_POST['USUARIS']))
		{	
			if($_POST['USUARIS']['Contrasenya']!="Introduir nova Contrasenya"){
				$_POST['USUARIS']['Contrasenya']=md5($_POST['USUARIS']['Contrasenya']);
			} else {
				unset($_POST['USUARIS']['Contrasenya']);
			}
			
			$model->attributes=$_POST['USUARIS'];
			if($model->save())
				$this->redirect(array('back/site/Usuaris'));
		}
		$model->attributes=array('Contrasenya'=>"Introduir nova Contrasenya");
		$this->render('Usuarisupdate',array(
				'model'=>$model,
		));
	}
	
	public function actionDeleteUsuaris($id)
	{
		$this->loadModel($id)->delete();
	
		// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
		if(!isset($_GET['ajax']))
			$this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('Usuaris'));
	}
	
	public function loadModel($id)
	{
		$model=USUARIS::model()->findByPk($id);
		if($model===null)
			throw new CHttpException(404,'The requested page does not exist.');
		return $model;
	}
	
	public function actionBdSmartMeter(){
		ini_set('display_errors', 1);
		ini_set('memory_limit', '4096M');
		set_time_limit(864000);
		//obtenir LLista d'arxius del servidor extern
		try{
			$smartmeter = new Smartmeter();
			$bdpropia= new Bdades();
			$fitxers=$smartmeter->getSmartmeterList();
	
		} catch (Exception $e){
			$e->getMessage();
			die("ERROR: ".$e);
	
		}
		//Comparar arxius del servidor extern amb els k ja tenim descarregats a la carpeta tempmeteo
		// i descarregar els que falten
		$fitxersguardats=$smartmeter->newSmartmeterFile($fitxers);
		//ultima data guardada al nostre servidor
		$ultimregaux=$bdpropia->getUltimreg("SmartMeter");

		//pasar de UTC a horari español
		$ultimreg=$ultimregaux;
		//pasar de UTCData a UTCnumeric (treure - i :)
		$ultimregaux=str_replace('-','',$ultimregaux);
		$ultimregaux=str_replace(':','',$ultimregaux);
		$ultimregaux=str_replace(' ','',$ultimregaux);
		//Lista de tots els arxius que hi ha descarregats al servidor
		$fitxers = scandir(Yii::getPathOfAlias('webroot')."/tempsmartmeter");
		//Eliminar els primers 4 elements dels fitxers perque son les carpetes pare o
		// elements que no volem
		array_splice($fitxers,0,4);
		//ordenar els fitxers
		$fitxers= $smartmeter->newLastDateFiles($fitxers,($ultimregaux));
		//Agafem la llista de fitxers en grup petits per evitar arrays que ens ocupin tota la memoria
		$nfitxers=count($fitxers);
		if($nfitxers>0){
			$tempdad=[];
			$tempdad=$smartmeter->getFilesData($fitxers);
			//Agafar les columnes 2,3 i 4 de tempdad i crear la data i l'hora en UTC
			$tempdad=$smartmeter->createFileDate($tempdad);
			//tornem a ordenar per si alguna dade a quedat desubicada
			//eliminem dades duplicades i inferiors a l'ultim registre
			$tempdad=$smartmeter->deletDuplicated($tempdad,$ultimregaux);
			
			//guardar les dades a la base de dades;
			$bdpropia->insertSmartMeter($tempdad);
			//guardar l'ultim tempdad per a la proxima iteraci�
		}
		$this->redirect(Yii::app()->request->urlReferrer);
	}
	
}