<?php

class SiteController extends Controller
{
	public function filters(){
		ini_set('display_errors', 1);
		return array(
				'accessControl',
		);
	}
	
	public function accessRules(){
		return array(
			array(
				'allow',
				'users'=>array('@'),
			),
			array(
				'allow',
				'ips'=>array('127.0.0.1'),
			),
			array(
				'allow',
				'users'=>array('*'),
				'actions'=>array('contact','login'),
			),
			array(
				'deny',
				'users'=>array('*'),
			),
		);
	}
	
	/**
	 * Declares class-based actions.
	 */
	public function actions()
	{
		return array(
			// captcha action renders the CAPTCHA image displayed on the contact page
			'captcha'=>array(
				'class'=>'CCaptchaAction',
				'backColor'=>0xFFFFFF,
			),
			// page action renders "static" pages stored under 'protected/views/site/pages'
			// They can be accessed via: index.php?r=site/page&view=FileName
			'page'=>array(
				'class'=>'CViewAction',
			),
		);
	}

	/**
	 * This is the default 'index' action that is invoked
	 * when an action is not explicitly requested by users.
	 */
	public function actionIndex()
	{
		// renders the view file 'protected/views/site/index.php'
		// using the default layout 'protected/views/layouts/main.php'

		if(!Yii::app()->user->isGuest||CHttpRequest::getUserHostAddress()=='127.0.0.1'){
			$this->render('index');
		} else {
			$this->redirect('/site/login');
		}
		
	}

	/**
	 * This is the action to handle external exceptions.
	 */
	public function actionError()
	{
		if($error=Yii::app()->errorHandler->error)
		{
			if(Yii::app()->request->isAjaxRequest)
				echo $error['message'];
			else
				$this->render('error', $error);
		}
	}

	/**
	 * Displays the contact page
	 */
	public function actionContact()
	{
		$this->redirect('http://exit.udg.edu/contact.aspx');
	}

	/**
	 * Displays the login page
	 */
	public function actionLogin()
	{
		$model=new LoginForm;

		// if it is ajax validation request
		if(isset($_POST['ajax']) && $_POST['ajax']==='login-form')
		{
			echo CActiveForm::validate($model);
			Yii::app()->end();
		}

		// collect user input data
		if(isset($_POST['LoginForm']))
		{	
			$_POST['LoginForm']['password']=md5($_POST['LoginForm']['password']);
//			die(print_r($_POST['LoginForm']['password']));
			$model->attributes=$_POST['LoginForm'];
			// validate user input and redirect to the previous page if valid
			if($model->validate() && $model->login())
				$this->redirect(Yii::app()->user->returnUrl);
		}
		// display the login form
		$this->render('login',array('model'=>$model));
	}

	/**
	 * Logs out the current user and redirect to homepage.
	 */
	public function actionLogout()
	{
		Yii::app()->user->logout();
		$this->redirect(Yii::app()->homeUrl);
	}

	
	public function actionDownloadCsv($data){
		ini_set('memory_limit', '2048M');
		$name=$data.".csv";
		if($data=="MM"){
			$name="Mesh-Met".".csv";
			$fileHandler=fopen($name,"a+");
			$file=file($name);
			$n=count($file);
			if($file){
				$i=1;
				$linia=explode(",",$file[$n-$i]);
				$ultimregmesh=$linia[0];
				$ultimregmesh=str_replace('"',"",$ultimregmesh);
				while($linia[24]==null){
					unset($file[$n-$i]);
					$i++;
					$linia=explode(",",$file[$n-$i]);
				}
				$ultimreg=$linia[0];
				$ultimreg=str_replace('"',"",$ultimreg);
				if($ultimreg<$ultimregmesh){
					unset($file[$n-$i]);
					file_put_contents($name,$file);
				}
			} else {
				$ultimreg=0;
			}
			$info=$this->actiongetMet_Mesh($ultimreg);
		} else if($data=="MME") {
			$name="Mesh-Met-Ener".".csv";
			$fileHandler=fopen($name,"a+");
			$file=file($name);
			$n=count($file);
			if($file){
				$i=1;
				$linia=explode(",",$file[$n-$i]);
				$ultimregmesh=$linia[0];
				$ultimregmesh=str_replace('"',"",$ultimregmesh);
				while($linia[24]==null){
					unset($file[$n-$i]);
					$i++;
					$linia=explode(",",$file[$n-$i]);
				}
				$ultimreg=$linia[0];
				$ultimreg=str_replace('"',"",$ultimreg);
				if($ultimreg<$ultimregmesh){
					unset($file[$n-$i]);
					file_put_contents($name,$file);
				}
			} else {
				$ultimreg=0;
			}
			$info=$this->actiongetMet_Mesh_Ener($ultimreg);
		} else if($data=="QUIM"){
			$name="QUIM".".csv";
			$fileHandler=fopen($name,"a+");
			$file=file($name);
			$n=count($file);
			if($file){
				$i=1;
				$linia=explode(",",$file[$n-$i]);
				$ultimregmesh=$linia[4]."-".$linia[3]."-".$linia[1]." ".$linia[2];
				while($linia[28]==null){
					unset($file[$n-$i]);
					$i++;
					$linia=explode(",",$file[$n-$i]);
				}
				$ultimreg=$linia[4]."-".$linia[3]."-".$linia[1]." ".$linia[2];
				$ninstancia=$linia[0];
				if($ultimreg<$ultimregmesh){
					unset($file[$n-$i]);
					file_put_contents($name,$file);
				}
			} else {
				$ultimreg=0;
				$ninstancia=1;
			}
			$info=$this->actionCsvQuim($ultimreg);
		} else {
			$fileHandler=fopen($name,"a+");
			$file=file($name);
			if($file){
				$linia=explode(",",$file[count($file)-1]);
				$ultimreg=$linia[0];
				$ultimreg=str_replace('"',"",$ultimreg);
			} else {
				$ultimreg=0;
			}
			if($data=="SmartMeter"){
				$info= Yii::app()->db->createCommand("SELECT * FROM ".$data." WHERE Data>'".$ultimreg."'")->queryAll();
			} else {
				$info= Yii::app()->db->createCommand("SELECT * FROM ".$data." WHERE UTCData>'".$ultimreg."'")->queryAll();
			}
		}
		if($ultimreg==0){
			$title=[];
			if($data=="QUIM"){
				foreach ($info[0] as $key=>$inf){
					if($key=="UTCData"){
						$title[]="Ninstancia";
						$title[]="Dia";
						$title[]="Hora";
						$title[]="Mes";
						$title[]="Any";
						$title[]="Dia_7";
						$title[]="Laboral";
					} else {
						$title[]=$key;
					}
				}
				fputcsv($fileHandler,$title);
			} else {
				foreach ($info[0] as $key=>$inf){
					$title[]=$key;
				}
				fputcsv($fileHandler,$title);
			}
		}
		if($data=='QUIM'){
			foreach ($info as $inf){
				unset($title);
				foreach ($inf as $key=>$in){
					if($key=="UTCData"){
						$extra=$this->dies_7($in);
						$title[]=$ninstancia;
						$ninstancia++;
						$title[]=$extra[2];
						$title[]=$extra[3];
						$title[]=$extra[1];
						$title[]=$extra[0];
						$title[]=$extra[4];
						$title[]="";
					} else {
						$title[]=$in;
					}
				}
				fputcsv($fileHandler,$title); 
			}
		} else {
			foreach ($info as $inf){
				fputcsv($fileHandler,$inf);
			}
		}
		fclose($fileHandler);
		Yii::trace('5- enviar','Projecte');
		Yii::app()->getRequest()->sendFile($name,file_get_contents($name),"text/csv",false);
	}
	
public function dies_7($data){
	$any = substr($data,0,4);
	$mes = substr($data,5,2);
	$dia = substr($data,8,2);
	$hora= substr($data,11,8);
	
	$timestamp = strtotime($any."-".$mes."-".$dia);

	$dia_7=date("w",$timestamp);
	if($dia_7==0){
		$dia_7=7;
	}
	return array($any,$mes,$dia,$hora,$dia_7);
}
	
	public function actiongetMet_Mesh($ultimreg){
		
		ini_set('memory_limit', '2048M');
		$Db=new Bdades();
		//LLegir l'ultim csv guardat
		
		$meshlium=$Db->getData($ultimreg,"MESHLIUM");
		if($meshlium){
			$meteo=$Db->getData($meshlium[0]['UTCData'],"METEO");
			$mitj=[];
			$k=[];
			Yii::trace('1- inici foreach','Projecte');
			//		set_time_limit(400);
			$j=0;
			foreach ($meshlium as $key=>$mesh){
				Yii::trace('1.1- inici calcul temps '.$key,'Projecte');
				unset($mitj);
				unset($k);
				$temps=$Db->UTCtoUTCN($meshlium[$key]['UTCData']);
				$tmax=$temps+2500;
				$tmin=$Db->UTCNremovetime($temps,30);
				//Iniciar els valors de la variable mitj
				for($i=0;$i<12;$i++){
					if(isset($meteo[$i+$j])){
						if($i==0){
							if($Db->UTCtoUTCN($meteo[$i+$j]['UTCData'])!=$tmin){
								Yii::log('error linia inici temps '.$Db->UTCtoUTCN($meteo[$i+$j]['UTCData'])." tindria que ser ".$tmin,CLogger::LEVEL_ERROR,'Projecte');
							}
						}
						if($i==11){
							if($Db->UTCtoUTCN($meteo[$i+$j]['UTCData'])!=$tmax){
								Yii::log('error linia fi del temps'.$Db->UTCtoUTCN($meteo[$i+$j]['UTCData'])." tindria que ser ".$tmax,CLogger::LEVEL_ERROR,'Projecte');
							}
						}
						foreach($meteo[$i+$j] as $key2=>$met){
							if($key2!='UTCData'){
								if(!is_null($met)){
									if(!isset($mitj[$key2])){
										$mitj[$key2]=$met;
										$k[$key2]=1;
									} else {
										$mitj[$key2]=$mitj[$key2]+$met;
										$k[$key2]++;
									}
								} else {
									$mitj[$key2]=null;
								}
							}
						}
					}
				}
				$j = $j+12;
				if(isset($mitj)){
					foreach ($mitj as $key3=>$m){
						if($m!=null){
							$meshlium[$key][$key3]=$mitj[$key3]/$k[$key3];
						} else {
							$meshlium[$key][$key3]=null;
						}
					}
				} else {
					for($i=0;$i<9;$i++){
						$meshlium[$key][]="";
					}
				}
			}
		} 
		Yii::trace('2- fi foreach','Projecte');
		return $meshlium;
	}
	
	public function actiongetMet_Mesh_Ener($ultimreg){
		ini_set('memory_limit', '2048M');
		$Db=new Bdades();
		$meshlium=$Db->getData($ultimreg,"MESHLIUM");
		if($meshlium){
			$meteo=$Db->getData($meshlium[0]['UTCData'],"METEO");
			$energia=$Db->getData($meshlium[0]['UTCData'],"ENERGIA");
			$mitj=[];
			$k=[];
			Yii::trace('1- inici foreach','Projecte');
			//		set_time_limit(400);
			$j1=0;
			$j2=0;
			foreach ($meshlium as $key=>$mesh){
				Yii::trace('1.1- inici calcul temps '.$key,'Projecte');
				unset($mitj);
				unset($k);
				$temps=$Db->UTCtoUTCN($meshlium[$key]['UTCData']);
				$tmax=$temps+2500;
				$tmin=$Db->UTCNremovetime($temps,30);
			
				Yii::trace('1.1- inici Meteo ','Projecte');
				unset($mitj);
				//Meteo
				for($i=0;$i<12;$i++){
					if(isset($meteo[$i+$j1])){
						if($i==0){
							if($Db->UTCtoUTCN($meteo[$i+$j1]['UTCData'])!=$tmin){
								Yii::log('error linia inici temps '.$meteo[$i+$j1]['UTCData']." tindria que ser ".$tmin,CLogger::LEVEL_ERROR,'Projecte');
							}
						}
						if($i==11){
							if($Db->UTCtoUTCN($meteo[$i+$j1]['UTCData'])!=$tmax){
								Yii::log('error linia fi del temps'.$meteo[$i+$j1]['UTCData']." tindria que ser ".$tmax,CLogger::LEVEL_ERROR,'Projecte');
							}
						}
						foreach($meteo[$i+$j1] as $key2=>$met){
							if($key2!='UTCData'){
								if(!is_null($met)){
									if(!isset($mitj[$key2])){
										$mitj[$key2]=$met;
										$k[$key2]=1;
									} else {
										$mitj[$key2]=$mitj[$key2]+$met;
										$k[$key2]++;
									}
								} else {
									$mitj[$key2]=null;
								}
							}
						}
					}
				}
				$j1 = $j1+12;
				if(isset($mitj)){
					Yii::trace('1.2- inici for','Projecte');
					foreach ($mitj as $key3=>$m){
						if($m!=null){
							$meshlium[$key][$key3]=$mitj[$key3]/$k[$key3];
						} else {
							$meshlium[$key][$key3]=null;
						}
						
					}
				} else {
					for($i=0;$i<9;$i++){
						$meshlium[$key][]="";
					}
				}
				//ENERGIA
				Yii::trace('2.1- inici ENERGIA ','Projecte');
				unset($k);
				unset($mitj);
				for($i=0;$i<4;$i++){
					Yii::trace('2.1- ENERGIA '.$i,'Projecte');
					if(isset($energia[$i+$j2])){
						if($i==0){
							if($Db->UTCtoUTCN($energia[$i+$j2]['UTCData'])!=$tmin){
								Yii::log('error linia inici temps '.$energia[$i+$j2]['UTCData']." tindria que ser ".$tmin,CLogger::LEVEL_ERROR,'Projecte');
							}
						}
						if($i==11){
							if($Db->UTCtoUTCN($energia[$i+$j2]['UTCData'])!=$tmax){
								Yii::log('error linia fi del temps'.$energia[$i+$j2]['UTCData']." tindria que ser ".$tmax,CLogger::LEVEL_ERROR,'Projecte');
							}
						}
						foreach($energia[$i+$j2] as $key2=>$met){
							if($key2!='UTCData'){
								if(!is_null($met)){
									if(!isset($mitj[$key2])){
										$mitj[$key2]=$met;
										$k[$key2]=1;
									} else {
										$mitj[$key2]=$mitj[$key2]+$met;
										$k[$key2]++;
									}
								}  else {
									$mitj[$key2]=null;
								}
							}
						}
					}
				}
					
				$j2 = $j2+4;
				if(isset($mitj)){
					Yii::trace('1.2- inici for ','Projecte');
					foreach ($mitj as $key3=>$m){
						if($m!=null){
							$meshlium[$key][$key3]=$m/$k[$key3];
						} else {
							$meshlium[$key][$key3]=null;
						}
						
					}
				} else {
					Yii::trace('2.1- no $mitj','Projecte');
					for($i=0;$i<27;$i++){
						$meshlium[$key][]="";
					}
				}
			}
		}
		
		Yii::trace('2- fi foreach','Projecte');
		return $meshlium;
	}
	
public function actionCsvQuim($ultimreg){
	ini_set('memory_limit', '2048M');
	$Db=new Bdades();
	$meshlium=$Db->getData($ultimreg,"MESHLIUM");
	if($meshlium){
		$meteo=$Db->getData($meshlium[0]['UTCData'],"METEO");
		$energia=$Db->getData($meshlium[0]['UTCData'],"ENERGIA");
		$mitj=[];
		$k=[];
		Yii::trace('1- inici foreach','Projecte');
		//		set_time_limit(400);
		$j1=0;
		$j2=0;
		foreach ($meshlium as $key=>$mesh){
			Yii::trace('1.1- inici calcul temps '.$key,'Projecte');
			unset($mitj);
			unset($k);
			$temps=$Db->UTCtoUTCN($meshlium[$key]['UTCData']);
			$tmax=$temps+2500;
			$tmin=$Db->UTCNremovetime($temps,30);
				
			Yii::trace('1.1- inici Meteo ','Projecte');
			unset($mitj);
			//Meteo
			for($i=0;$i<12;$i++){
				if(isset($meteo[$i+$j1])){
					if($i==0){
						if($Db->UTCtoUTCN($meteo[$i+$j1]['UTCData'])!=$tmin){
							Yii::log('error minim linia inici temps '.$meteo[$i+$j1]['UTCData']." tindria que ser ".$tmin,CLogger::LEVEL_ERROR,'Projecte');
						}
					}
					if($i==11){
						if($Db->UTCtoUTCN($meteo[$i+$j1]['UTCData'])!=$tmax){
							Yii::log('error maxim linia fi del temps'.$meteo[$i+$j1]['UTCData']." tindria que ser ".$tmax,CLogger::LEVEL_ERROR,'Projecte');
						}
					}
					foreach($meteo[$i+$j1] as $key2=>$met){
						if($key2=='GLO'||$key2=='T_AIR'||$key2=='RH_AIR'){
							if(!is_null($met)){
								if(!isset($mitj[$key2])){
									$mitj[$key2]=$met;
									$k[$key2]=1;
								} else {
									$mitj[$key2]=$mitj[$key2]+$met;
									$k[$key2]++;
								}
							} else {
								$mitj[$key2]=null;
							}
						}
					}
				}
			}
			$j1 = $j1+12;
			if(isset($mitj)){
				Yii::trace('1.2- inici for','Projecte');
				foreach ($mitj as $key3=>$m){
					if($m!=null){
						$meshlium[$key][$key3]=$mitj[$key3]/$k[$key3];
					} else {
						$meshlium[$key][$key3]=null;
					}
	
				}
			} else {
				$meshlium[$key]["GLO"]="";
				$meshlium[$key]["T_AIR"]="";
				$meshlium[$key]["RH_AIR"]="";
			}
			//ENERGIA
			Yii::trace('2.1- inici ENERGIA ','Projecte');
			unset($k);
			unset($mitj);
			for($i=0;$i<4;$i++){
				Yii::trace('2.1- ENERGIA '.$i,'Projecte');
				if(isset($energia[$i+$j2])){
					if($i==0){
						if($Db->UTCtoUTCN($energia[$i+$j2]['UTCData'])!=$tmin){
							Yii::log('error linia inici temps '.$energia[$i+$j2]['UTCData']." tindria que ser ".$tmin,CLogger::LEVEL_ERROR,'Projecte');
						}
					}
					if($i==11){
						if($Db->UTCtoUTCN($energia[$i+$j2]['UTCData'])!=$tmax){
							Yii::log('error linia fi del temps'.$energia[$i+$j2]['UTCData']." tindria que ser ".$tmax,CLogger::LEVEL_ERROR,'Projecte');
						}
					}
					foreach($energia[$i+$j2] as $key2=>$met){
						if($key2=='Montilivi_PIV_Nor'||$key2=='Montilivi_PIV_Per'){
							if(!is_null($met)){
								if(!isset($mitj[$key2])){
									$mitj[$key2]=$met;
									$k[$key2]=1;
								} else {
									$mitj[$key2]=$mitj[$key2]+$met;
									$k[$key2]++;
								}
							}  else {
								$mitj[$key2]=null;
							}
						}
					}
				}
			}
				
			$j2 = $j2+4;
			if(isset($mitj)){
				Yii::trace('1.2- inici for ','Projecte');
				foreach ($mitj as $key3=>$m){
					if($m!=null){
						$meshlium[$key][$key3]=$m/$k[$key3];
					} else {
						$meshlium[$key][$key3]=null;
					}
	
				}
			} else {
				Yii::trace('2.1- no $mitj','Projecte');
				$meshlium[$key]["Montilivi_PIV_Nor"]="";
				$meshlium[$key]["Montilivi_PIV_Per"]="";
			}
		}
	}
	
	Yii::trace('2- fi foreach','Projecte');
	return $meshlium;
}

	public function actionMeteo(){
		$model=new METEO('search');
		$model->unsetAttributes();  // clear any default values
		if(isset($_GET['METEO']))
			$model->attributes=$_GET['METEO'];
		$data=$model->getlast7Days();
		$this->render('meteo',array('model'=>$model,'data'=>$data));
	}
	
	public function actionMeshlium(){
		$model=new MESHLIUM('search');
		$model->unsetAttributes();  // clear any default values
		if(isset($_GET['MESHLIUM'])){
			$model->attributes=$_GET['MESHLIUM'];
		}
		$data=$model->getlast7Days();
		$this->render('meshlium',array('model'=>$model,'data'=>$data));
	}
	
	public function actionEnergia(){
		$model=new ENERGIA('search');
		$model->unsetAttributes();  // clear any default values
		if(isset($_GET['ENERGIA'])){
			$model->attributes=$_GET['ENERGIA'];
		}
		$data=$model->getlast7Days();
		$this->render('energia',array('model'=>$model,'data'=>$data));
	}
	
	public function actionSmartMeter(){
		$model=new SmartMeter('search');
		$model->unsetAttributes();  // clear any default values
		if(isset($_GET['ENERGIA'])){
			$model->attributes=$_GET['SmartMeter'];
		}
//		$data=$model->getlast7Days();
		$sensors =$model->getId();
		$this->render('smartmeter',array('model'=>$model,'sensors'=>$sensors));
	}
	
	public function actionSensors(){
		$this->layout='//layouts/column2';
		if(Yii::app()->user->id=='Administrador'||CHttpRequest::getUserHostAddress()=='127.0.0.1'){
			$models=new SENSORS('search');
			$models->unsetAttributes();
			if(isset($_GET['SENSORS'])){
				$models->attributes=$_GET['SENSORS'];
			}
			$modelb=new SENSORSBATTERY('search');
			$modelb->unsetAttributes();
			if(isset($_GET['SENSORSBATTERY'])){
				$modelb->attributes=$_GET['SENSORSBATTERY'];
			}
			$modelc=new Correus('search');
			$modelc->unsetAttributes();
			if(isset($_GET['SENSORSBATTERY'])){
				$modelb->attributes=$_GET['SENSORSBATTERY'];
			}
			$data=$modelb->getlast7Days();
			
			$this->render('sensors',array('models'=>$models,'modelb'=>$modelb,'modelc'=>$modelc,'data'=>$data));
		} else {
			$this->redirect('index');
		}
		
	}
	
	public function actionSensorsUpdate($id){

		$model=SENSORS::model()->findByPk($id);
		if($model===null){
			throw new CHttpException(404,'The request page does not exist.');
		}
		if(isset($_POST['SENSORS'])){
			$model->attributes=$_POST['SENSORS'];
			if($model->save()){
				echo 'save';
				$this->redirect(array('sensors'));
			}
		}
		$this->layout='//layouts/column2';
		$this->render('updateSensors',array('model'=>$model,));
	}
	
	public function actionSensorsCreate(){
		$model= new SENSORS();
		$this->layout='//layouts/column2';
		if(isset($_POST['SENSORS'])){
			$model->attributes=$_POST['SENSORS'];
			if($model->save()){
				$this->redirect(array('sensors'));
			}
		}
		
		$this->render('createSensors',array('model'=>$model,));
	}
	
	public function actionSensorsDelete($id){
		$model=SENSORS::model()->findByPk($id);
		if($model===null){
			throw new CHttpException(404,'The requested page does not exist.');
		} else {
			$model->delete();
		}

		// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
		if(!isset($_GET['ajax']))
			$this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('sensors'));
	}
	
	public function actionCorreusCreate(){
		$model= new Correus();
		$this->layout='//layouts/column2';
		if(isset($_POST['Correus'])){
			$model->attributes=$_POST['Correus'];
			if($model->save()){
				$this->redirect(array('sensors'));
			}
		}
		
		$this->render('createCorreu',array('model'=>$model,));
	}
	
	public function actionCorreuUpdate($id){
		$model=Correus::model()->findByPk($id);
		if($model===null){
			throw new CHttpException(404,'The request page does not exist.');
		}
		if(isset($_POST['Correus'])){
			$model->attributes=$_POST['Correus'];
			if($model->save()){
				echo 'save';
				$this->redirect(array('sensors'));
			}
		}
		$this->layout='//layouts/column2';
		$this->render('updateCorreu',array('model'=>$model,));
	}
	
	public function actionCorreuDelete($id){
		$model=Correus::model()->findByPk($id);
		if($model===null){
				throw new CHttpException(404,'The requested page does not exist.');
		} else {
			$model->delete();
		}
		// if AJAX request (triggered by deletion via admin grid view), we should not redirect the browser
		if(!isset($_GET['ajax']))
			$this->redirect(isset($_POST['returnUrl']) ? $_POST['returnUrl'] : array('sensors'));
	}
	
	public function actionUpdatePassword(){
		$model=USUARIS::model()->findByAttributes(array('Usuari'=>Yii::app()->user->name));
		if($model===null)
			throw new CHttpException(404,'The requested page does not exist.');
		
		if(isset($_POST['USUARIS']))
		{
			if($_POST['USUARIS']['Contrasenya']!="Introduir nova Contrasenya"){
				$_POST['USUARIS']['Contrasenya']=md5($_POST['USUARIS']['Contrasenya']);
			} else {
				unset($_POST['USUARIS']['Contrasenya']);
			}
				
			$model->attributes=$_POST['USUARIS'];
			if($model->save())
				$this->redirect(array('/site/index'));
		}
		$model->attributes=array('Contrasenya'=>"Introduir nova Contrasenya");
		$this->render('Usuarisupdate',array(
				'model'=>$model,
		));
	}
	
	public function actionDownloadInfo($data){
		ini_set('memory_limit', '2048M');
		$name=$data.".txt";
		Yii::app()->getRequest()->sendFile($name,file_get_contents($name),"text/txt",false);
	}
}