<?php

class Bdades extends CActiveRecord{
	private $connection;
	
	public function __construct(){
		$this->connection = new CDbConnection(Yii::app()->db->connectionString,Yii::app()->db->username,Yii::app()->db->password);
		$this->connection->active=true;
	}
	
	public static function model($className=__CLASS__){
		return  parent::model($className);
	}
	
	public function insertMeteo($tempdad){
		$sql="INSERT INTO METEO (UTCData,GLO,DIF,T_AIR,RH_AIR,PRESS,PREC,WIND_V,WIND_D,Dir_SD) VALUES (?,?,?,?,?,?,?,?,?,?)";
		$command=$this->connection->createCommand($sql);
		foreach ($tempdad as $temp){
			//Posar informació de la data
			$command->bindValue(1,$temp[10],PDO::PARAM_STR);
			//Posar informació GLO
			$command->bindValue(2,$temp[1],PDO::PARAM_STR);
			//Posar informació DIF
			$command->bindValue(3,$temp[2],PDO::PARAM_STR);
			//Posar informació T AIR
			$command->bindValue(4,$temp[3],PDO::PARAM_STR);
			//Posar informació RH AIR
			$command->bindValue(5,$temp[4],PDO::PARAM_STR);
			//Posar informació PRESS-
			$command->bindValue(6,$temp[5],PDO::PARAM_STR);
			//Posar informació PREC
			$command->bindValue(7,$temp[6],PDO::PARAM_STR);
			//Posar informació WIND V
			$command->bindValue(8,$temp[7],PDO::PARAM_STR);
			//Posar informació WIND D
			$command->bindValue(9,$temp[8],PDO::PARAM_STR);
			//Posar informació WIND D
			$command->bindValue(10,$temp[9],PDO::PARAM_STR);
			
			$command->execute();
		}
		return true;
	}
	
	public function getUltimreg($bdades){
		if($bdades=="SmartMeter"){
			$sql="SELECT MAX(Data) FROM  ".$bdades;
		} else {
			$sql="SELECT MAX(UTCData) FROM  ".$bdades;
		}
		$command=$this->connection->createCommand($sql);
		$ultimreg=$command->queryAll();
		if($bdades=="SmartMeter"){
			if(!isset($ultimreg[0]["MAX(Data)"])){
				return 0;
			}
			return $ultimreg[0]["MAX(Data)"];
		} else {
			if(!isset($ultimreg[0]["MAX(UTCData)"])){
				return 0;
			}
		}
		
		return $ultimreg[0]["MAX(UTCData)"];
	}
	
	public function insertMeshlium($tempdad){
		$sql="INSERT INTO MESHLIUM (UTCData,T_1,LL_1,HR_1,T_2,LL_2,HR_2,T_3,LL_3,HR_3,T_4,LL_4,HR_4,T_5,LL_5,HR_5,T_6,LL_6,HR_6,P_7,P_8) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
		$command=$this->connection->createCommand($sql);
		foreach ($tempdad as $temp){
			//TimeStamp pasa de la columna 10 a la primera
			for($i=1;$i<22;$i++){
				if(isset($temp[$i])){
					$command->bindValue($i,$temp[$i],PDO::PARAM_STR);
				} else {
					$command->bindValue($i,null,PDO::PARAM_STR);
				}
			}	
			$command->execute();
		}
		return true;
	}
	
	public function deletMeshliumUltimreg(){
		$sql="DELETE FROM `MESHLIUM` ORDER BY UTCData DESC LIMIT 2";
		$command=$this->connection->createCommand($sql);
		$ultimreg=$command->execute();
	}
	
	public function insertSensorsBattery($tempdad){
		$sql="INSERT INTO SensorsBattery (UTCData,S1,S2,S3,S4,S5,S6,S7,S8) VALUES (?,?,?,?,?,?,?,?,?)";
		$command=$this->connection->createCommand($sql);
		foreach ($tempdad as $temp){
			//TimeStamp pasa de la columna 10 a la primera
			for($i=0;$i<9;$i++){
				if(isset($temp[$i])){
					$command->bindValue($i+1,$temp[$i],PDO::PARAM_STR);
				} else {
					$command->bindValue($i+1,null,PDO::PARAM_STR);
				}
			}
			$command->execute();
		}
		return true;
	}
	
	public function deletSensorsBatteryUltimreg(){
		$sql="DELETE FROM `SensorsBattery` ORDER BY UTCData DESC LIMIT 1";
		$command=$this->connection->createCommand($sql);
		$ultimreg=$command->execute();
	}
	
	//Info per els csv
	public function getData($Data,$bdades){
		if($bdades!="Meshlium"){
			$Data=$this->UTCtoUTCN($Data);
			$Data=$this->UTCNremovetime($Data,30);
			$Data=$this->UTCNtoUTC($Data);
		}
		$sql="SELECT * FROM  ".$bdades." WHERE UTCData>='".$Data."'";
		$command=$this->connection->createCommand($sql);
		$info=$command->queryAll();
		return $info;
	}
	
	//FI csv
	public function UTCtoUTCN($data){
		$data=str_replace(":","",$data);
		$data=str_replace("-","",$data);
		$data=str_replace(" ","",$data);
		return $data;
	}
	
	public function UTCNtoUTC($data){
		$data=substr_replace($data,":",12,0);
		$data=substr_replace($data,":",10,0);
		$data=substr_replace($data," ",8,0);
		$data=substr_replace($data,"-",6,0);
		$data=substr_replace($data,"-",4,0);
		return $data;
	}
	
	public function UTCNremovetime($timestamp,$min){
		$any=substr($timestamp,0,4);
		$mes=substr($timestamp,4,2);
		$dia=substr($timestamp,6,2);
		$hora=substr($timestamp,8,2);
	
		if(($hora-1)<0){
			$hora=23;
			if(($dia-1)<=0){
				if(($mes-1)<=0){
					$any--;
					$mes=12;
					$dia=31;
				} else {
					$mes--;
					if($mes<10){
						$mes='0'.$mes;
					}
					$hora=23;
					$dia=cal_days_in_month(CAL_GREGORIAN,$mes,$any);
				}
			} else {
				$dia--;
				if($dia<10){
					$dia='0'.$dia;
				}
			}
		} else {
			$hora--;
			if($hora<10){
				$hora="0".$hora;
			}
		}
		
	
		return $any.$mes.$dia.$hora.$min."00";
	}
	
	public function UTCNaddtime($data,$quantitat){
		if(((substr($data,10,2)+$quantitat)>=60)){
			if((substr($data,8,2)+1)>=24){
				if((substr($data,6,2)+1)>cal_days_in_month(CAL_GREGORIAN,substr($data,4,2),substr($data,0,4))){
					if(substr($data,4,2)+1>12){
						//sumar 1 any
						$data=$data+10000000000;
						$data=substr_replace($data,"0101000000",4,10);
					} else {
						//sumar 1 mes si són més dies que el d'aquell mes
						$data=$data+100000000;
						$data=substr_replace($data,"01000000",6,8);
					}
				} else {
					//sumar 1 dia si son més de 24 hores
					$data=$data+1000000;
					$data=substr_replace($data,"000000",8,6);
				}
			} else {
				//sumar 1h si son més de 60 min
				$data=$data+10000;
				$data=substr_replace($data,"0000",10,4);
			}
		} else {
			$data=$data+1500;
		}
		return $data;
	}
	
	public function getSensors(){
		$sql="SELECT * FROM  Sensors";
		$command=$this->connection->createCommand($sql);
		$sensors=$command->queryAll();
		return $sensors;
	}
	
	public function UpdateBatSensors($bateria,$sensor){
		$sql="UPDATE Sensors SET Bateria='".$bateria."' WHERE Sensor=".$sensor;
		$command=$this->connection->createCommand($sql);
		$command->execute();
	}
	
	public function getCorreus(){
		$sql="SELECT * FROM  Correus";
		$command=$this->connection->createCommand($sql);
		$correus=$command->queryAll();
		return $correus;
	}
	
	public function getEnergiaEdificis(){
		$sql="SELECT * FROM EdificisEnergia";
		$command=$this->connection->createCommand($sql);
		$columns=$command->queryAll();
		return $columns;
	}
	
	public function afegirColumna($nom){
		$afegir=true;
		$dbSchema=$this->connection->schema;
		$table=$dbSchema->getTable("ENERGIA");
		$columns=$table->columns;
		foreach ($columns as $column){
			if($nom==$column->name){
				$afegir=false;
			}
		}
		if($afegir){
			$sql="ALTER TABLE `ENERGIA` ADD `".$nom."` float";
			$command=$this->connection->createCommand($sql);
			$command->execute();
		}
	}
	
	public function InsertEnergia($time,$dades,$edificis){
		$colum="`UTCdata`";
		$inter="?";
		if(isset($dades)){
			foreach ($dades as $key=>$dada){
				$colum=$colum.",`".$edificis[$key]['Nom']."`";
				$inter=$inter.","."?";
			}
		}
		$sql="INSERT INTO ENERGIA (".$colum.") VALUES (".$inter.")";
		$command=$this->connection->createCommand($sql);
		$command->bindValue(1,$time,PDO::PARAM_STR);
		$i=1;
		if(isset($dades)){
			foreach ($dades as $key=>$dada){
				$i++;
				$command->bindValue($i,$dada[0]["Value"],PDO::PARAM_STR);
			}
		}
		$command->execute();
		return true;
		}
	public function getSmartmeterUltimreg(){
		$sql="SELECT MAX(UTCData) FROM  METEO";
		$command=$this->connection->createCommand($sql);
		$ultimreg=$command->queryAll();
		if(!isset($ultimreg[0]["MAX(UTCData)"])){
			return 0;
		}
		return $ultimreg[0]["MAX(UTCData)"];
	}
	
	public function insertSmartMeter($tempdad){
		$sql="INSERT INTO SmartMeter (Id,Data,Bc,AI,AE,R1,R2,R3,R4) VALUES (?,?,?,?,?,?,?,?,?)";
		$command=$this->connection->createCommand($sql);
		foreach ($tempdad as $key=>$temp){
			foreach ($temp as $linia){
				//Posar informació de la Id
				$command->bindValue(1,$key,PDO::PARAM_STR);
				//Posar informació Data
				$command->bindValue(2,$linia["Data"],PDO::PARAM_STR);
				//Posar informació Bc
				$command->bindValue(3,$linia["Bc"],PDO::PARAM_STR);
				//Posar informació AI
				$command->bindValue(4,$linia["AI"],PDO::PARAM_STR);
				//Posar informació AE
				$command->bindValue(5,$linia["AE"],PDO::PARAM_STR);
				//Posar informació R1
				$command->bindValue(6,$linia["R1"],PDO::PARAM_STR);
				//Posar informació R2
				$command->bindValue(7,$linia["R2"],PDO::PARAM_STR);
				//Posar informació R3
				$command->bindValue(8,$linia["R3"],PDO::PARAM_STR);
				//Posar informació R4
				$command->bindValue(9,$linia["R4"],PDO::PARAM_STR);
				
				$command->execute();
			}
		}
		return true;
	}
}