<?php

/**
 * This is the model class for table "Correus".
 *
 * The followings are the available columns in table 'Correus':
 * @property string $Nom
 * @property string $correu
 * @property integer $Nivell_Bat
 */
class Correus extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'Correus';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('Nom, correu, Nivell_Bat', 'required'),
			array('Nivell_Bat', 'numerical', 'integerOnly'=>true),
			array('Nom, correu', 'length', 'max'=>25),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('ID, Nom, correu, Nivell_Bat', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'ID' => 'ID',
			'Nom' => 'Nom',
			'correu' => 'Correu',
			'Nivell_Bat' => 'Avis al nivell de Batteria',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;
		
		$criteria->compare('Nom',$this->Nom,true);
		$criteria->compare('correu',$this->correu,true);
		$criteria->compare('Nivell_Bat',$this->Nivell_Bat);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return Correus the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
