<?php

/**
 * This is the model class for table "ENERGIA".
 *
 * The followings are the available columns in table 'ENERGIA':
 * @property string $UTCData
 * @property double $Barri_Vell_Aligues
 * @property double $Barri_Vell_FEP_Bar
 * @property double $Barri_Vell_FEP_Clima
 * @property double $Barri_Vell_FEP_Enllumenat
 * @property double $Barri_Vell_FEP_Forza
 * @property double $Barri_Vell_FEP_Fotocopies
 * @property double $Barri_Vell_FEP_General
 * @property double $Barri_Vell_FEP_Informatica
 * @property double $Barri_Vell_SAI
 * @property double $Barri_Vell_StDomenec
 * @property double $Montilivi_Aulari
 * @property double $Montilivi_Biblioteca
 * @property double $Montilivi_Ciencies
 * @property double $Montilivi_Dret
 * @property double $Montilivi_Economiques
 * @property double $Montilivi_M20
 * @property double $Montilivi_PI
 * @property double $Montilivi_PII
 * @property double $Montilivi_PIII
 * @property double $Montilivi_PIII_Clima
 * @property double $Montilivi_PIII_Copisteria
 * @property double $Montilivi_PIII_EnlluEndolls
 * @property double $Montilivi_PIII_General
 * @property double $Montilivi_PIII_Informatica
 * @property double $Montilivi_PIII_Permanent
 * @property double $Montilivi_PIV_Nor
 * @property double $Montilivi_PIV_Per
 */
class ENERGIA extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'ENERGIA';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('UTCData', 'required'),
			array('Barri_Vell_Aligues, Barri_Vell_FEP_Bar, Barri_Vell_FEP_Clima, Barri_Vell_FEP_Enllumenat, Barri_Vell_FEP_Forza, Barri_Vell_FEP_Fotocopies, Barri_Vell_FEP_General, Barri_Vell_FEP_Informatica, Barri_Vell_SAI, Barri_Vell_StDomenec, Montilivi_Aulari, Montilivi_Biblioteca, Montilivi_Ciencies, Montilivi_Dret, Montilivi_Economiques, Montilivi_M20, Montilivi_PI, Montilivi_PII, Montilivi_PIII, Montilivi_PIII_Clima, Montilivi_PIII_Copisteria, Montilivi_PIII_EnlluEndolls, Montilivi_PIII_General, Montilivi_PIII_Informatica, Montilivi_PIII_Permanent, Montilivi_PIV_Nor, Montilivi_PIV_Per', 'numerical'),
			array('UTCData', 'length', 'max'=>25),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('UTCData, Barri_Vell_Aligues, Barri_Vell_FEP_Bar, Barri_Vell_FEP_Clima, Barri_Vell_FEP_Enllumenat, Barri_Vell_FEP_Forza, Barri_Vell_FEP_Fotocopies, Barri_Vell_FEP_General, Barri_Vell_FEP_Informatica, Barri_Vell_SAI, Barri_Vell_StDomenec, Montilivi_Aulari, Montilivi_Biblioteca, Montilivi_Ciencies, Montilivi_Dret, Montilivi_Economiques, Montilivi_M20, Montilivi_PI, Montilivi_PII, Montilivi_PIII, Montilivi_PIII_Clima, Montilivi_PIII_Copisteria, Montilivi_PIII_EnlluEndolls, Montilivi_PIII_General, Montilivi_PIII_Informatica, Montilivi_PIII_Permanent, Montilivi_PIV_Nor, Montilivi_PIV_Per', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'UTCData' => 'Utcdata',
			'Barri_Vell_Aligues' => 'Barri Vell Aligues',
			'Barri_Vell_FEP_Bar' => 'Barri Vell Fep Bar',
			'Barri_Vell_FEP_Clima' => 'Barri Vell Fep Clima',
			'Barri_Vell_FEP_Enllumenat' => 'Barri Vell Fep Enllumenat',
			'Barri_Vell_FEP_Forza' => 'Barri Vell Fep Forza',
			'Barri_Vell_FEP_Fotocopies' => 'Barri Vell Fep Fotocopies',
			'Barri_Vell_FEP_General' => 'Barri Vell Fep General',
			'Barri_Vell_FEP_Informatica' => 'Barri Vell Fep Informatica',
			'Barri_Vell_SAI' => 'Barri Vell Sai',
			'Barri_Vell_StDomenec' => 'Barri Vell St Domenec',
			'Montilivi_Aulari' => 'Montilivi Aulari',
			'Montilivi_Biblioteca' => 'Montilivi Biblioteca',
			'Montilivi_Ciencies' => 'Montilivi Ciencies',
			'Montilivi_Dret' => 'Montilivi Dret',
			'Montilivi_Economiques' => 'Montilivi Economiques',
			'Montilivi_M20' => 'Montilivi M20',
			'Montilivi_PI' => 'Montilivi Pi',
			'Montilivi_PII' => 'Montilivi Pii',
			'Montilivi_PIII' => 'Montilivi Piii',
			'Montilivi_PIII_Clima' => 'Montilivi Piii Clima',
			'Montilivi_PIII_Copisteria' => 'Montilivi Piii Copisteria',
			'Montilivi_PIII_EnlluEndolls' => 'Montilivi Piii Enllu Endolls',
			'Montilivi_PIII_General' => 'Montilivi Piii General',
			'Montilivi_PIII_Informatica' => 'Montilivi Piii Informatica',
			'Montilivi_PIII_Permanent' => 'Montilivi Piii Permanent',
			'Montilivi_PIV_Nor' => 'Montilivi Piv Nor',
			'Montilivi_PIV_Per' => 'Montilivi Piv Per',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;
		
		$criteria->order='UTCData DESC';

		$criteria->compare('UTCData',$this->UTCData,true);
		$criteria->compare('Barri_Vell_Aligues',$this->Barri_Vell_Aligues);
		$criteria->compare('Barri_Vell_FEP_Bar',$this->Barri_Vell_FEP_Bar);
		$criteria->compare('Barri_Vell_FEP_Clima',$this->Barri_Vell_FEP_Clima);
		$criteria->compare('Barri_Vell_FEP_Enllumenat',$this->Barri_Vell_FEP_Enllumenat);
		$criteria->compare('Barri_Vell_FEP_Forza',$this->Barri_Vell_FEP_Forza);
		$criteria->compare('Barri_Vell_FEP_Fotocopies',$this->Barri_Vell_FEP_Fotocopies);
		$criteria->compare('Barri_Vell_FEP_General',$this->Barri_Vell_FEP_General);
		$criteria->compare('Barri_Vell_FEP_Informatica',$this->Barri_Vell_FEP_Informatica);
		$criteria->compare('Barri_Vell_SAI',$this->Barri_Vell_SAI);
		$criteria->compare('Barri_Vell_StDomenec',$this->Barri_Vell_StDomenec);
		$criteria->compare('Montilivi_Aulari',$this->Montilivi_Aulari);
		$criteria->compare('Montilivi_Biblioteca',$this->Montilivi_Biblioteca);
		$criteria->compare('Montilivi_Ciencies',$this->Montilivi_Ciencies);
		$criteria->compare('Montilivi_Dret',$this->Montilivi_Dret);
		$criteria->compare('Montilivi_Economiques',$this->Montilivi_Economiques);
		$criteria->compare('Montilivi_M20',$this->Montilivi_M20);
		$criteria->compare('Montilivi_PI',$this->Montilivi_PI);
		$criteria->compare('Montilivi_PII',$this->Montilivi_PII);
		$criteria->compare('Montilivi_PIII',$this->Montilivi_PIII);
		$criteria->compare('Montilivi_PIII_Clima',$this->Montilivi_PIII_Clima);
		$criteria->compare('Montilivi_PIII_Copisteria',$this->Montilivi_PIII_Copisteria);
		$criteria->compare('Montilivi_PIII_EnlluEndolls',$this->Montilivi_PIII_EnlluEndolls);
		$criteria->compare('Montilivi_PIII_General',$this->Montilivi_PIII_General);
		$criteria->compare('Montilivi_PIII_Informatica',$this->Montilivi_PIII_Informatica);
		$criteria->compare('Montilivi_PIII_Permanent',$this->Montilivi_PIII_Permanent);
		$criteria->compare('Montilivi_PIV_Nor',$this->Montilivi_PIV_Nor);
		$criteria->compare('Montilivi_PIV_Per',$this->Montilivi_PIV_Per);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
			'pagination' => array(
					'pageSize' => Yii::app()->user->getState( 'pageSize', Yii::app()->params[ 'defaultPageSize' ] ),
			),
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return ENERGIA the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
	
	public function getlast7days(){
		$connection = new CDbConnection(Yii::app()->db->connectionString,Yii::app()->db->username,Yii::app()->db->password);
		$connection->active=true;
		$sql="SELECT * FROM `ENERGIA` ORDER BY UTCData DESC LIMIT 672";
		$command=$connection->createCommand($sql);
		$data=$command->queryAll();
		return $data;
	}
}
