<?php

/**
 * This is the model class for table "MESHLIUM".
 *
 * The followings are the available columns in table 'MESHLIUM':
 * @property string $Data
 * @property double $T_1
 * @property double $LL_1
 * @property double $HR_1
 * @property double $T_2
 * @property double $LL_2
 * @property double $HR_2
 * @property double $T_3
 * @property double $LL_3
 * @property double $HR_3
 * @property double $T_4
 * @property double $LL_4
 * @property double $HR_4
 * @property double $T_5
 * @property double $LL_5
 * @property double $HR_5
 * @property double $T_6
 * @property double $LL_6
 * @property double $HR_6
 * @property double $P_7
 * @property double $P_8
 */
class MESHLIUM extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'MESHLIUM';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('UTCData', 'required'),
			array('T_1, LL_1, HR_1, T_2, LL_2, HR_2, T_3, LL_3, HR_3, T_4, LL_4, HR_4, T_5, LL_5, HR_5, T_6, LL_6, HR_6, P_7, P_8', 'numerical'),
			array('UTCData', 'length', 'max'=>25),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('UTCData, T_1, LL_1, HR_1, T_2, LL_2, HR_2, T_3, LL_3, HR_3, T_4, LL_4, HR_4, T_5, LL_5, HR_5, T_6, LL_6, HR_6, P_7, P_8', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'UTCData' => 'UTCData',
			'T_1' => 'T 1',
			'LL_1' => 'Ll 1',
			'HR_1' => 'Hr 1',
			'T_2' => 'T 2',
			'LL_2' => 'Ll 2',
			'HR_2' => 'Hr 2',
			'T_3' => 'T 3',
			'LL_3' => 'Ll 3',
			'HR_3' => 'Hr 3',
			'T_4' => 'T 4',
			'LL_4' => 'Ll 4',
			'HR_4' => 'Hr 4',
			'T_5' => 'T 5',
			'LL_5' => 'Ll 5',
			'HR_5' => 'Hr 5',
			'T_6' => 'T 6',
			'LL_6' => 'Ll 6',
			'HR_6' => 'Hr 6',
			'P_7' => 'P 7',
			'P_8' => 'P 8',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;
		
		$criteria->order='UTCData DESC';

		$criteria->compare('UTCData',$this->UTCData,true);
		$criteria->compare('T_1',$this->T_1);
		$criteria->compare('LL_1',$this->LL_1);
		$criteria->compare('HR_1',$this->HR_1);
		$criteria->compare('T_2',$this->T_2);
		$criteria->compare('LL_2',$this->LL_2);
		$criteria->compare('HR_2',$this->HR_2);
		$criteria->compare('T_3',$this->T_3);
		$criteria->compare('LL_3',$this->LL_3);
		$criteria->compare('HR_3',$this->HR_3);
		$criteria->compare('T_4',$this->T_4);
		$criteria->compare('LL_4',$this->LL_4);
		$criteria->compare('HR_4',$this->HR_4);
		$criteria->compare('T_5',$this->T_5);
		$criteria->compare('LL_5',$this->LL_5);
		$criteria->compare('HR_5',$this->HR_5);
		$criteria->compare('T_6',$this->T_6);
		$criteria->compare('LL_6',$this->LL_6);
		$criteria->compare('HR_6',$this->HR_6);
		$criteria->compare('P_7',$this->P_7);
		$criteria->compare('P_8',$this->P_8);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
			'pagination' => array(
				'pageSize' => Yii::app()->user->getState( 'pageSize', Yii::app()->params[ 'defaultPageSize' ] ),
			),
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return MESHLIUM the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
	
	public function getlast7days(){
		$connection = new CDbConnection(Yii::app()->db->connectionString,Yii::app()->db->username,Yii::app()->db->password);
		$connection->active=true;
		$sql="SELECT * FROM `MESHLIUM` ORDER BY UTCData DESC LIMIT 168";
		$command=$connection->createCommand($sql);
		$data=$command->queryAll();
		return $data;
	}
}
