<?php

/**
 * This is the model class for table "Sensors".
 *
 * The followings are the available columns in table 'Sensors':
 * @property integer $Sensor
 * @property string $altMAC
 * @property string $baixMAC
 */
class SENSORS extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'Sensors';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('altMAC, baixMAC', 'required'),
			array('altMAC, baixMAC', 'length', 'max'=>10),
			array('Bateria', 'length', 'max'=>8),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('Sensor, altMAC, baixMAC, Bateria', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'Sensor' => 'Sensor',
			'altMAC' => 'Alt Mac',
			'baixMAC' => 'Baix Mac',
			'Bateria' => 'Bateria',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;

		$criteria->compare('Sensor',$this->Sensor);
		$criteria->compare('altMAC',$this->altMAC,true);
		$criteria->compare('baixMAC',$this->baixMAC,true);
		$criteria->compare('Bateria',$this->Bateria);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
			'pagination' => array(
						'pageSize' => Yii::app()->user->getState( 'pageSize', Yii::app()->params[ 'defaultPageSize' ] ),
			),
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return SENSORS the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
}
