<?php

/**
 * This is the model class for table "SensorsBattery".
 *
 * The followings are the available columns in table 'SensorsBattery':
 * @property string $UTCData
 * @property integer $S1
 * @property integer $S2
 * @property integer $S3
 * @property integer $S4
 * @property integer $S5
 * @property integer $S6
 * @property integer $S7
 * @property integer $S8
 */
class SENSORSBATTERY extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'SensorsBattery';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('UTCData', 'required'),
			array('S1, S2, S3, S4, S5, S6, S7, S8', 'numerical', 'integerOnly'=>true),
			array('UTCData', 'length', 'max'=>25),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('UTCData, S1, S2, S3, S4, S5, S6, S7, S8', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'UTCData' => 'Utcdata',
			'S1' => 'S1',
			'S2' => 'S2',
			'S3' => 'S3',
			'S4' => 'S4',
			'S5' => 'S5',
			'S6' => 'S6',
			'S7' => 'S7',
			'S8' => 'S8',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search()
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;
		
		$criteria->order='UTCData DESC';

		$criteria->compare('UTCData',$this->UTCData,true);
		$criteria->compare('S1',$this->S1);
		$criteria->compare('S2',$this->S2);
		$criteria->compare('S3',$this->S3);
		$criteria->compare('S4',$this->S4);
		$criteria->compare('S5',$this->S5);
		$criteria->compare('S6',$this->S6);
		$criteria->compare('S7',$this->S7);
		$criteria->compare('S8',$this->S8);

		return new CActiveDataProvider($this, array(
		'criteria'=>$criteria,
			'pagination' => array(
					'pageSize' => Yii::app()->user->getState( 'pageSize', Yii::app()->params[ 'defaultPageSize' ] ),
			),
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return SENSORSBATTERY the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
	
	public function getlast7days(){
		$connection = new CDbConnection(Yii::app()->db->connectionString,Yii::app()->db->username,Yii::app()->db->password);
		$connection->active=true;
		$sql="SELECT * FROM `SensorsBattery` ORDER BY UTCData ASC";
		$command=$connection->createCommand($sql);
		$data=$command->queryAll();
		return $data;
	}
}
