<?php

/**
 * This is the model class for table "SmartMeter".
 *
 * The followings are the available columns in table 'SmartMeter':
 * @property string $Id
 * @property string $Data
 * @property integer $Bc
 * @property integer $AI
 * @property integer $AE
 * @property integer $R1
 * @property integer $R2
 * @property integer $R3
 * @property integer $R4
 */
class SmartMeter extends CActiveRecord
{
	/**
	 * @return string the associated database table name
	 */
	public function tableName()
	{
		return 'SmartMeter';
	}

	/**
	 * @return array validation rules for model attributes.
	 */
	public function rules()
	{
		// NOTE: you should only define rules for those attributes that
		// will receive user inputs.
		return array(
			array('Id, Data, Bc, AI, AE, R1, R2, R3, R4', 'required'),
			array('Bc, AI, AE, R1, R2, R3, R4', 'numerical', 'integerOnly'=>true),
			array('Id', 'length', 'max'=>14),
			array('Data', 'length', 'max'=>25),
			// The following rule is used by search().
			// @todo Please remove those attributes that should not be searched.
			array('Id, Data, Bc, AI, AE, R1, R2, R3, R4', 'safe', 'on'=>'search'),
		);
	}

	/**
	 * @return array relational rules.
	 */
	public function relations()
	{
		// NOTE: you may need to adjust the relation name and the related
		// class name for the relations automatically generated below.
		return array(
		);
	}

	/**
	 * @return array customized attribute labels (name=>label)
	 */
	public function attributeLabels()
	{
		return array(
			'Id' => 'ID',
			'Data' => 'Data',
			'Bc' => 'Bc',
			'AI' => 'Ai',
			'AE' => 'Ae',
			'R1' => 'R1',
			'R2' => 'R2',
			'R3' => 'R3',
			'R4' => 'R4',
		);
	}

	/**
	 * Retrieves a list of models based on the current search/filter conditions.
	 *
	 * Typical usecase:
	 * - Initialize the model fields with values from filter form.
	 * - Execute this method to get CActiveDataProvider instance which will filter
	 * models according to data in model fields.
	 * - Pass data provider to CGridView, CListView or any similar widget.
	 *
	 * @return CActiveDataProvider the data provider that can return the models
	 * based on the search/filter conditions.
	 */
	public function search($Id)
	{
		// @todo Please modify the following code to remove attributes that should not be searched.

		$criteria=new CDbCriteria;
		
		$criteria->order='Data DESC';

		$criteria->condition=('Id="'.$Id.'"');
		$criteria->compare('Data',$this->Data,true);
		$criteria->compare('Bc',$this->Bc);
		$criteria->compare('AI',$this->AI);
		$criteria->compare('AE',$this->AE);
		$criteria->compare('R1',$this->R1);
		$criteria->compare('R2',$this->R2);
		$criteria->compare('R3',$this->R3);
		$criteria->compare('R4',$this->R4);

		return new CActiveDataProvider($this, array(
			'criteria'=>$criteria,
			'pagination' => array(
				'pageSize' => Yii::app()->user->getState( 'pageSize', Yii::app()->params[ 'defaultPageSize' ] ),
			),
		));
	}

	/**
	 * Returns the static model of the specified AR class.
	 * Please note that you should have this exact method in all your CActiveRecord descendants!
	 * @param string $className active record class name.
	 * @return SmartMeter the static model class
	 */
	public static function model($className=__CLASS__)
	{
		return parent::model($className);
	}
	
	public function getlast7days($Id){
		$connection = new CDbConnection(Yii::app()->db->connectionString,Yii::app()->db->username,Yii::app()->db->password);
		$connection->active=true;
		$sql="SELECT * FROM `SmartMeter` WHERE Id =='".$Id."' ORDER BY Data DESC LIMIT 2016";
		$command=$connection->createCommand($sql);
		$data=$command->queryAll();
		return $data;
	}
	
	public function getId(){
		$connection = new CDbConnection(Yii::app()->db->connectionString,Yii::app()->db->username,Yii::app()->db->password);
		$connection->active=true;
		$sql="SELECT DISTINCT Id FROM `SmartMeter`";
		$command=$connection->createCommand($sql);
		$data=$command->queryAll();
		return $data;
	}
	
}
