//-----------------------Definicions-------------------------//
#define macMesh "0013A2004081D548" //Mac del Meshlium
//#define macMesh "0013A200406FB25A"
#define  macHigh "0013A200" //Mac Wasp alta es fixe
//----------------------Fi_Definicions-----------------------//

//-----------------------Var_Globals-------------------------//
char macLow[9]="XXXXXXXX";//Mac Wasp baixa s'iniciara in fer el setup
char mac[17]="";

//dades dels sensors i bateria
char T[10];
char L[10];
char H[10];
int P=0;
int S=0;
int S2=-1;
int nintents=100;
uint8_t batteryLevel=-100;

//Indica si hi ha error enviant el paquet
boolean error=true;

long previous=0;///temps inici l'execucio
long tempsdormir=3600000;//temps que hem de dormir
char temps[12]="00:00:00:00";//temps dormir-temps execuccio
int msegons=0;//temps que sobra
//-----------------------Fi_Var_Globals----------------------//

void setup(){
  //Init clock
  RTC.ON();
  RTC.setTime("00:00:00:00:00:00:00");
  RTC.OFF();

  //init Zigbee
  xbeeZB.init(ZIGBEE,FREQ2_4G,PRO);//inicialitza les variables que utilitza el Zigbee
  xbeeZB.ON();
  
  //getOwnMac
  while(xbeeZB.getOwnMac()==1){}
  Utils.hex2str(xbeeZB.sourceMacLow,macLow,4);
  strcpy(mac,macHigh);
  strcat(mac,macLow);
  //parem zigbee
  xbeeZB.OFF();
}

void loop(){
 int intents=0;
 USB.begin();
  //Rellotge on
  RTC.ON();

  //agafem el temps actual
  previous=millis();
  
  LLegirSensors(); 
  //iniciem l'Xbee
  xbeeZB.init(ZIGBEE,FREQ2_4G,PRO);
  xbeeZB.ON();
  delay(500);
  xbeeZB.getAssociationIndication();
    while(xbeeZB.associationIndication !=0&intents<nintents){
      delay(1000);
      xbeeZB.getAssociationIndication();
      intents++;
    }
    if(intents!=nintents){
      EnviarInfo();
    } else {
      S=1;
    }
  //apaguem xbee
  xbeeZB.OFF();
  S2=S;
  PrepTemps();
  PWR.deepSleep(temps,RTC_OFFSET,RTC_ALM1_MODE2,SENS_OFF|UART0_OFF|UART1_OFF|BAT_OFF);
}

void LLegirSensors(){
  //engeguem la taula
  SensorSmartv20.setBoardMode(SENS_ON);
  
  //Turn on sensors
  SensorSmartv20.setSensorMode(SENS_ON, SENS_SMART_TEMPERATURE);//on socket 6
  SensorSmartv20.setSensorMode(SENS_ON, SENS_SMART_LDR);//on socket 7
  SensorSmartv20.setSensorMode(SENS_ON, SENS_SMART_HUMIDITY);//on socket 8
  
  //esperem a que els sensors iniciin 
  delay(100);
  
  //Llegim sensors
  Utils.float2String(SensorSmartv20.readValue(SENS_SMART_TEMPERATURE),T,6);//on socket 6
  Utils.float2String(SensorSmartv20.readValue(SENS_SMART_LDR),L,6);//on socket 7
  Utils.float2String(SensorSmartv20.readValue(SENS_SMART_HUMIDITY),H,6);//on socket 8
  
  //Turn off sensors
  SensorSmartv20.setSensorMode(SENS_OFF, SENS_SMART_TEMPERATURE);
  SensorSmartv20.setSensorMode(SENS_OFF, SENS_SMART_LDR);
  SensorSmartv20.setSensorMode(SENS_OFF, SENS_SMART_HUMIDITY);
  
  //apaguem sensor board
  SensorSmartv20.setBoardMode(SENS_OFF);
  
  //Llegim la bateria
  PWR.getBatteryLevel();
  batteryLevel=PWR.getBatteryLevel();
}

void EnviarInfo(){
  int intents=0;
  //creem el frame
  frame.createFrame(ASCII,mac);
  frame.setFrameSize(ZIGBEE,UNICAST_64B,0,0);
  frame.setFrameType(SERVICE1_FRAME);
  char aux[80];
  sprintf(aux,"%u;%s;%s;%s;%d;%d",batteryLevel, T, L, H, P,S2);
  frame.addSensor(SENSOR_STR,aux);
  
  //Creem el paquet
  packetXBee* paq_sent=(packetXBee*) calloc(1,sizeof(packetXBee)); 
  paq_sent->mode=UNICAST;
  paq_sent->packetID=0x52;
  paq_sent->opt=0; 
  xbeeZB.setOriginParams(paq_sent,mac,MAC_TYPE);
  
  //preparem el data
  char data[frame.length+1];
  for(uint8_t i=0;i<frame.length;i++){
  data[i]=frame.buffer[i];
 } 
 data[frame.length+1]='\0';
  xbeeZB.setDestinationParams(paq_sent,macMesh,data,MAC_TYPE,DATA_ABSOLUTE);
  
  //enviem
  xbeeZB.sendXBee(paq_sent);
   while(xbeeZB.error_TX&intents<nintents){//Si error tornem a enviar
    xbeeZB.sendXBee(paq_sent);
    intents++;
    delay(1000);
  }
  if(intents!=nintents){
    S=0;
  } else {
    S=2;
  }
  //alliberem paquet
  free(paq_sent);
  paq_sent=NULL;
}

void PrepTemps(){
  //restem 5 millisegons que és el temps que tarda en executar les comandes restants
  long diftemps =millis()-previous-5;
  if(diftemps<0){
    previous=tempsdormir;
  } else {
     previous=tempsdormir-diftemps;
  }
 
  //perque no dormi negatius ni temps masa petits
  if(previous<=1000){
    previous=1000;
  }
  //arrodonim a +1 o -1 segon els milis que sobren
  ldiv_t tim=ldiv(previous,1000);
  msegons=msegons+tim.rem;
  if(msegons>1000){
   tim=ldiv((tim.quot+1),60);
   msegons=msegons-1000;
  }else{
   tim=ldiv(tim.quot,60);
  }
  int minuts = tim.quot;
  int segons = tim.rem;
  sprintf(temps,"00:00:%02d:%02d",minuts,segons);
}
