//-----------------------Definicions-------------------------//
#define macMesh "0013A2004081D548" //Mac del Meshlium
//#define macMesh "0013A200406FB25A" //Mac USB
#define  macHigh "0013A200" //Mac Wasp alta es fixe
//----------------------Fi_Definicions-----------------------//

//-----------------------Var_Globals-------------------------//
#include "WProgram.h"
void setup();
void loop();
void LLegirSensors();
void EnviarInfo();
void PrepTemps();
char macLow[9]="XXXXXXXX";//Mac Wasp baixa s'iniciara en fer el setup
char mac[17]="";

//dades dels sensors i bateria
char T[10];
char L[10];
char H[10];
int P=0;
int S=0;
int S2=-1;
int nintents=100;
uint8_t batteryLevel=-100;

//Indica si hi ha error enviant el paquet
boolean error=true;

long previous=0;///temps inici l'execucio
long tempsdormir=3600000;//temps que hem de dormir
char temps[12]="00:00:00:00";//temps dormir-temps execuccio
int msegons=0;//temps que sobra
//-----------------------Fi_Var_Globals----------------------//


void setup(){
  //Init clock
  RTC.ON();
  RTC.setTime("00:00:00:00:00:00:00");
  RTC.OFF();
  
  // Activem la placa de sensors
  SensorEvent.setBoardMode(SENS_ON);
  //enable sensor board interruptions
  enableInterrupts(SENS_INT);
  
  //init Zigbee
  xbeeZB.init(ZIGBEE,FREQ2_4G,PRO);//inicialitza les variables que utilitza el Zigbee 
  xbeeZB.ON();
  
  //getOwnMac
  while(xbeeZB.getOwnMac()==1){}
  Utils.hex2str(xbeeZB.sourceMacLow,macLow,4);
  strcpy(mac,macHigh);
  strcat(mac,macLow);
  //parem zigbee
  xbeeZB.OFF();
  RTC.setAlarm1("00:00:00:01",RTC_OFFSET,RTC_ALM1_MODE2);
  SensorEvent.loadInt();
  SensorEvent.intFlag=0;
}

void loop()
{
  SensorEvent.attachInt();
  PWR.sleep(UART0_OFF|UART1_OFF|BAT_OFF);
  SensorEvent.detachInt();
  //Rellotge on
  RTC.ON();
  //agafem el temps actual
  previous=millis();
  LLegirSensors(); 
  if(intFlag & RTC_INT)
  {
     SensorEvent.setBoardMode(SENS_OFF);
    //iniciem l'Xbee
    int intents=0;
    //Llegim la bateria
    PWR.getBatteryLevel();
    batteryLevel=PWR.getBatteryLevel();
    xbeeZB.init(ZIGBEE,FREQ2_4G,PRO);
    xbeeZB.ON();
    delay(1000);
    xbeeZB.getAssociationIndication();
    while(xbeeZB.associationIndication !=0&intents<nintents){
      delay(1000);
      xbeeZB.getAssociationIndication();
      intents++;
    }
    if(intents!=nintents){
      EnviarInfo();
    } else {
      S=1;
    }
    //apaguem xbee
    xbeeZB.OFF();
   SensorEvent.setBoardMode(SENS_ON);
   SensorEvent.loadInt();
   SensorEvent.intFlag=0;
    PrepTemps();
    P=0;
    S2=S;
    intFlag &= ~(RTC_INT);
    RTC.setAlarm1(temps,RTC_OFFSET,RTC_ALM1_MODE2);
  }
}

void LLegirSensors()
{
  SensorEvent.loadInt();
  if(SensorEvent.intFlag & SENS_SOCKET7)
  {
    P++;
    SensorEvent.intFlag=0;
  }
}


void EnviarInfo(){
  int intents=0;
  //creem el frame
  frame.createFrame(ASCII,mac);
  frame.setFrameSize(ZIGBEE,UNICAST_64B,0,0);
  frame.setFrameType(SERVICE1_FRAME);
  char aux[80];
  sprintf(aux,"%u;%s;%s;%s;%d;%d",batteryLevel, T, L, H, P,S2);
  frame.addSensor(SENSOR_STR,aux);
  
  //Creem el paquet
  packetXBee* paq_sent=(packetXBee*) calloc(1,sizeof(packetXBee)); 
  paq_sent->mode=UNICAST;
  paq_sent->packetID=0x52;
  paq_sent->opt=0; 
  xbeeZB.setOriginParams(paq_sent,mac,MAC_TYPE);
  
  //preparem el data
  char data[frame.length+1];
  for(uint8_t i=0;i<frame.length;i++){
  data[i]=frame.buffer[i];
 } 
 data[frame.length+1]='\0';
  xbeeZB.setDestinationParams(paq_sent,macMesh,data,MAC_TYPE,DATA_ABSOLUTE);
  
  //enviem
  xbeeZB.sendXBee(paq_sent);
   while(xbeeZB.error_TX&intents<nintents){//Si error tornem a enviar
    xbeeZB.sendXBee(paq_sent);
    intents++;
    delay(1000);
  }
  if(intents!=nintents){
    S=0;
  } else {
    S=2;
  }
  //alliberem paquet
  free(paq_sent);
  paq_sent=NULL;
}

void PrepTemps()
{
  //restem 5 millisegons que \u00e9s el temps que tarda en executar les comandes restants
  long diftemps =millis()-previous-5;
  if(diftemps<0){
    previous=tempsdormir;
  } else {
     previous=tempsdormir-diftemps;
  }
 
  //perque no dormi negatius ni temps masa petits
  if(previous<=1000){
    previous=1000;
  }
  //arrodonim a +1 o -1 segon els milis que sobren
  ldiv_t tim=ldiv(previous,1000);
  msegons=msegons+tim.rem;
  if(msegons>1000){
   tim=ldiv((tim.quot+1),60);
   msegons=msegons-1000;
  }else{
   tim=ldiv(tim.quot,60);
  }
  int minuts = tim.quot;
  int segons = tim.rem;
  if(minuts>60){
     minuts=60; 
  }
  if(segons>60){
     segons=60; 
  }
  sprintf(temps,"00:00:%02d:%02d",minuts,segons);
}


int main(void)
{
	init();

	setup();
    
	for (;;)
		loop();
        
	return 0;
}

